/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
	package it.eng;

	import java.math.BigDecimal;
import java.sql.Connection;
import java.util.ArrayList;

import net.sf.jasperreports.engine.JRDefaultScriptlet;
import net.sf.jasperreports.engine.JRScriptletException;
import net.sf.jasperreports.renderers.JCommonDrawableRenderer;

import org.jfree.chart.JFreeChart;

	public class RespectedMilestones extends JRDefaultScriptlet{

		private Connection dbConnection;
		private ReportUtilities ru;
		private String parArea="";
		private String parProject="";
		private String parMethod="";
		private String parCustomer="";
		
		
		private final int idKPI = 22;


		public void afterReportInit() throws JRScriptletException {

			try {
				// get db connection
				dbConnection = (Connection) this.getParameterValue("REPORT_CONNECTION");

				ru=new ReportUtilities(dbConnection); 

				// set idKPI


				// get meterChart value
				BigDecimal value = this.calculateValue(idKPI);

				// calculate kpi threshold
				int thresholdType = 0;
				int idUser = 0;
				int idThreshold = ru.calculateThreshold(thresholdType, idUser,idKPI);

				// get meterChart title
				String title = ru.getKPITitle(idKPI);
				
				parArea = (String) this.getParameterValue("AreaPar");
				parProject = (String) this.getParameterValue("ProjectPar");
				parCustomer = (String) this.getParameterValue("CustomerPar");
				parMethod = (String) this.getParameterValue("MethodPar");

				ru.fakeReports(parArea, parProject, parCustomer, parMethod);
				ArrayList<Pair> subs=ru.getSubtitles(parArea, parProject, parCustomer, parMethod);
				// create meter chart
				JFreeChart meterchart = ru.createMeterChart(value, title, idThreshold,subs);
				this.setVariableValue("Chart_meter", new JCommonDrawableRenderer(
						meterchart));

			} catch (Exception e) {
				throw new JRScriptletException(e);
			}
		}

		private BigDecimal calculateValue(int pIdKPI) throws JRScriptletException {
		return new BigDecimal(20);
		}


	}
